diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/block-ack-manager.cc ns-3.35/src/wifi/model/block-ack-manager.cc
--- ns-3.34/src/wifi/model/block-ack-manager.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/block-ack-manager.cc	2021-10-01 13:26:48.000000000 -0700
@@ -21,7 +21,7 @@
 #include "ns3/log.h"
 #include "ns3/simulator.h"
 #include "block-ack-manager.h"
-#include "wifi-remote-station-manager.h"
+#include "wifi-utils.h"
 #include "ctrl-headers.h"
 #include "mgt-headers.h"
 #include "wifi-mac-queue.h"
@@ -65,16 +65,20 @@
 BlockAckManager::BlockAckManager ()
 {
   NS_LOG_FUNCTION (this);
-  m_retryPackets = CreateObject<WifiMacQueue> ();
-  m_retryPackets->TraceConnectWithoutContext ("Expired", MakeCallback (&BlockAckManager::NotifyDiscardedMpdu, this));
 }
 
 BlockAckManager::~BlockAckManager ()
 {
   NS_LOG_FUNCTION (this);
-  m_queue = 0;
+}
+
+void
+BlockAckManager::DoDispose ()
+{
+  NS_LOG_FUNCTION (this);
   m_agreements.clear ();
-  m_retryPackets = 0;
+  m_bars.clear ();
+  m_queue = nullptr;
 }
 
 bool
@@ -112,9 +116,9 @@
 }
 
 void
-BlockAckManager::CreateAgreement (const MgtAddBaRequestHeader *reqHdr, Mac48Address recipient)
+BlockAckManager::CreateAgreement (const MgtAddBaRequestHeader *reqHdr, Mac48Address recipient, bool htSupported)
 {
-  NS_LOG_FUNCTION (this << reqHdr << recipient);
+  NS_LOG_FUNCTION (this << reqHdr << recipient << htSupported);
   std::pair<Mac48Address, uint8_t> key (recipient, reqHdr->GetTid ());
   OriginatorBlockAckAgreement agreement (recipient, reqHdr->GetTid ());
   agreement.SetStartingSequence (reqHdr->GetStartingSequence ());
@@ -123,7 +127,7 @@
   agreement.SetBufferSize (reqHdr->GetBufferSize());
   agreement.SetTimeout (reqHdr->GetTimeout ());
   agreement.SetAmsduSupport (reqHdr->IsAmsduSupported ());
-  agreement.SetHtSupported (m_stationManager->GetHtSupported () && m_stationManager->GetHtSupported (recipient));
+  agreement.SetHtSupported (htSupported);
   if (reqHdr->IsImmediateBlockAck ())
     {
       agreement.SetImmediateBlockAck ();
@@ -154,17 +158,6 @@
   AgreementsI it = m_agreements.find (std::make_pair (recipient, tid));
   if (it != m_agreements.end ())
     {
-      for (WifiMacQueue::ConstIterator i = m_retryPackets->begin (); i != m_retryPackets->end (); )
-        {
-          if ((*i)->GetHeader ().GetAddr1 () == recipient && (*i)->GetHeader ().GetQosTid () == tid)
-            {
-              i = m_retryPackets->Remove (i);
-            }
-          else
-            {
-              i++;
-            }
-        }
       m_agreements.erase (it);
       //remove scheduled BAR
       for (std::list<Bar>::const_iterator i = m_bars.begin (); i != m_bars.end (); )
@@ -221,12 +214,6 @@
   m_unblockPackets (recipient, tid);
 }
 
-Ptr<WifiMacQueue>
-BlockAckManager::GetRetransmitQueue (void)
-{
-  return m_retryPackets;
-}
-
 void
 BlockAckManager::StorePacket (Ptr<WifiMacQueueItem> mpdu)
 {
@@ -270,15 +257,17 @@
     }
   agreementIt->second.second.insert (it, mpdu);
   agreementIt->second.first.NotifyTransmittedMpdu (mpdu);
+  mpdu->SetInFlight ();
 }
 
 Ptr<const WifiMacQueueItem>
 BlockAckManager::GetBar (bool remove, uint8_t tid, Mac48Address address)
 {
+  Time now = Simulator::Now ();
   Ptr<const WifiMacQueueItem> bar;
-  // remove all expired MPDUs in the retransmission queue, so that Block Ack Requests
-  // (if needed) are scheduled
-  m_retryPackets->Remove (WifiMacQueue::EMPTY, true);
+  // remove all expired MPDUs from the head of the MAC queue, so that
+  // BlockAckRequest frames (if needed) are scheduled
+  m_queue->IsEmpty ();
 
   auto nextBar = m_bars.begin ();
 
@@ -304,7 +293,6 @@
               continue;
             }
           if (nextBar->skipIfNoDataQueued
-              && m_retryPackets->PeekByTidAndAddress (nextBar->tid, recipient) == m_retryPackets->end ()
               && m_queue->PeekByTidAndAddress (nextBar->tid, recipient) == m_queue->end ())
             {
               // skip this BAR as there is no data queued
@@ -314,15 +302,30 @@
           // remove expired outstanding MPDUs and update the starting sequence number
           for (auto mpduIt = it->second.second.begin (); mpduIt != it->second.second.end (); )
             {
-              if ((*mpduIt)->GetTimeStamp () + m_queue->GetMaxDelay () <= Simulator::Now ())
+              if (!(*mpduIt)->IsQueued ())
+                {
+                  // the MPDU is no longer in the EDCA queue
+                  mpduIt = it->second.second.erase (mpduIt);
+                  continue;
+                }
+
+              WifiMacQueue::ConstIterator queueIt = (*mpduIt)->GetQueueIterator ();
+
+              if ((*mpduIt)->GetTimeStamp () + m_queue->GetMaxDelay () <= now)
                 {
                   // MPDU expired
                   it->second.first.NotifyDiscardedMpdu (*mpduIt);
+                  // Remove from the EDCA queue and fire the Expired trace source, but the
+                  // consequent call to NotifyDiscardedMpdu does nothing (in particular,
+                  // does not schedule a BAR) because we have advanced the transmit window
+                  // and hence this MPDU became an old packet
+                  m_queue->TtlExceeded (queueIt, now);
                   mpduIt = it->second.second.erase (mpduIt);
                 }
               else
                 {
-                  mpduIt++;
+                  // MPDUs are typically in increasing order of remaining lifetime
+                  break;
                 }
             }
           // update BAR if the starting sequence number changed
@@ -347,13 +350,6 @@
   return bar;
 }
 
-bool
-BlockAckManager::HasPackets (void)
-{
-  NS_LOG_FUNCTION (this);
-  return (!m_retryPackets->IsEmpty () || GetBar (false) != 0);
-}
-
 uint32_t
 BlockAckManager::GetNBufferedPackets (Mac48Address recipient, uint8_t tid) const
 {
@@ -363,19 +359,7 @@
     {
       return 0;
     }
-  uint32_t nPackets = 0;
-  PacketQueueCI queueIt = (*it).second.second.begin ();
-  while (queueIt != (*it).second.second.end ())
-    {
-      uint16_t currentSeq = (*queueIt)->GetHeader ().GetSequenceNumber ();
-      nPackets++;
-      /* a fragmented packet must be counted as one packet */
-      while (queueIt != (*it).second.second.end () && (*queueIt)->GetHeader ().GetSequenceNumber () == currentSeq)
-        {
-          queueIt++;
-        }
-    }
-  return nPackets;
+  return it->second.second.size ();
 }
 
 void
@@ -385,11 +369,66 @@
   m_blockAckThreshold = nPackets;
 }
 
-void
-BlockAckManager::SetWifiRemoteStationManager (const Ptr<WifiRemoteStationManager> manager)
+BlockAckManager::PacketQueueI
+BlockAckManager::HandleInFlightMpdu (PacketQueueI mpduIt, MpduStatus status,
+                                     const AgreementsI& it, const Time& now)
 {
-  NS_LOG_FUNCTION (this << manager);
-  m_stationManager = manager;
+  NS_LOG_FUNCTION (this << **mpduIt << +static_cast<uint8_t> (status));
+
+  if (!(*mpduIt)->IsQueued ())
+    {
+      // MPDU is not in the EDCA queue (e.g., its lifetime expired and it was
+      // removed by another method), remove from the queue of in flight MPDUs
+      NS_LOG_DEBUG ("MPDU is not stored in the EDCA queue, drop MPDU");
+      return it->second.second.erase (mpduIt);
+    }
+
+  if (status == ACKNOWLEDGED)
+    {
+      // the MPDU has to be dequeued from the EDCA queue
+      m_queue->DequeueIfQueued (*mpduIt);
+      return it->second.second.erase (mpduIt);
+    }
+
+  WifiMacHeader& hdr = (*mpduIt)->GetHeader ();
+  WifiMacQueue::ConstIterator queueIt = (*mpduIt)->GetQueueIterator ();
+
+  NS_ASSERT (hdr.GetAddr1 () == it->first.first);
+  NS_ASSERT (hdr.IsQosData () && hdr.GetQosTid () == it->first.second);
+
+  if (it->second.first.GetDistance (hdr.GetSequenceNumber ()) >= SEQNO_SPACE_HALF_SIZE)
+    {
+      NS_LOG_DEBUG ("Old packet. Remove from the EDCA queue, too");
+      if (!m_droppedOldMpduCallback.IsNull ())
+        {
+          m_droppedOldMpduCallback (*queueIt);
+        }
+      m_queue->Remove (queueIt);
+      return it->second.second.erase (mpduIt);
+    }
+
+  auto nextIt = std::next (mpduIt);
+
+  if (m_queue->TtlExceeded (queueIt, now))
+    {
+      // WifiMacQueue::TtlExceeded() has removed the MPDU from the EDCA queue
+      // and fired the Expired trace source, which called NotifyDiscardedMpdu,
+      // which removed this MPDU from the in flight queue as well
+      NS_LOG_DEBUG ("MSDU lifetime expired, drop MPDU");
+      return nextIt;
+    }
+
+  if (status == STAY_INFLIGHT)
+    {
+      // the MPDU has to stay in flight, do nothing
+      return ++mpduIt;
+    }
+
+  NS_ASSERT (status == TO_RETRANSMIT);
+  (*mpduIt)->GetHeader ().SetRetry ();
+  (*mpduIt)->ResetInFlight ();  // no longer in flight; will be if retransmitted
+
+  return it->second.second.erase (mpduIt);
 }
 
 void
@@ -406,17 +445,13 @@
   NS_ASSERT (it != m_agreements.end ());
 
   // remove the acknowledged frame from the queue of outstanding packets
-  PacketQueueI queueIt = it->second.second.begin ();
-  while (queueIt != it->second.second.end ())
+  for (auto queueIt = it->second.second.begin (); queueIt != it->second.second.end (); ++queueIt)
     {
       if ((*queueIt)->GetHeader ().GetSequenceNumber () == mpdu->GetHeader ().GetSequenceNumber ())
         {
-          queueIt = it->second.second.erase (queueIt);
+          HandleInFlightMpdu (queueIt, ACKNOWLEDGED, it, Simulator::Now ());
+          break;
         }
-      else
-      {
-        queueIt++;
-      }
     }
 
   it->second.first.NotifyAckedMpdu (mpdu);
@@ -437,127 +472,80 @@
 
   // remove the frame from the queue of outstanding packets (it will be re-inserted
   // if retransmitted)
-  PacketQueueI queueIt = it->second.second.begin ();
-  while (queueIt != it->second.second.end ())
+  for (auto queueIt = it->second.second.begin (); queueIt != it->second.second.end (); ++queueIt)
     {
       if ((*queueIt)->GetHeader ().GetSequenceNumber () == mpdu->GetHeader ().GetSequenceNumber ())
         {
-          queueIt = it->second.second.erase (queueIt);
+          HandleInFlightMpdu (queueIt, TO_RETRANSMIT, it, Simulator::Now ());
+          break;
         }
-      else
-      {
-        queueIt++;
-      }
     }
-
-  // insert in the retransmission queue
-  InsertInRetryQueue (mpdu);
 }
 
-void
+std::pair<uint16_t,uint16_t>
 BlockAckManager::NotifyGotBlockAck (const CtrlBAckResponseHeader& blockAck, Mac48Address recipient,
-                                    const std::set<uint8_t>& tids, double rxSnr, double dataSnr,
-                                    const WifiTxVector& dataTxVector, size_t index)
+                                    const std::set<uint8_t>& tids, size_t index)
 {
-  NS_LOG_FUNCTION (this << blockAck << recipient << rxSnr << dataSnr << dataTxVector << index);
-  if (!blockAck.IsMultiTid ())
+  NS_LOG_FUNCTION (this << blockAck << recipient << index);
+  uint16_t nSuccessfulMpdus = 0;
+  uint16_t nFailedMpdus = 0;
+
+  NS_ABORT_MSG_IF (blockAck.IsBasic (), "Basic Block Ack is not supported");
+  NS_ABORT_MSG_IF (blockAck.IsMultiTid (), "Multi-TID Block Ack is not supported");
+
+  uint8_t tid = blockAck.GetTidInfo (index);
+  // If this is a Multi-STA Block Ack with All-ack context (TID equal to 14),
+  // use the TID passed by the caller.
+  if (tid == 14)
     {
-      uint8_t tid = blockAck.GetTidInfo (index);
-      // If this is a Multi-STA Block Ack with All-ack context (TID equal to 14),
-      // use the TID passed by the caller.
-      if (tid == 14)
-        {
-          NS_ASSERT (blockAck.GetAckType (index) && tids.size () == 1);
-          tid = *tids.begin ();
-        }
-      if (ExistsAgreementInState (recipient, tid, OriginatorBlockAckAgreement::ESTABLISHED))
-        {
-          bool foundFirstLost = false;
-          uint16_t nSuccessfulMpdus = 0;
-          uint16_t nFailedMpdus = 0;
-          AgreementsI it = m_agreements.find (std::make_pair (recipient, tid));
-          PacketQueueI queueEnd = it->second.second.end ();
-
-          if (it->second.first.m_inactivityEvent.IsRunning ())
-            {
-              /* Upon reception of a BlockAck frame, the inactivity timer at the
-                 originator must be reset.
-                 For more details see section 11.5.3 in IEEE802.11e standard */
-              it->second.first.m_inactivityEvent.Cancel ();
-              Time timeout = MicroSeconds (1024 * it->second.first.GetTimeout ());
-              it->second.first.m_inactivityEvent = Simulator::Schedule (timeout,
-                                                                        &BlockAckManager::InactivityTimeout,
-                                                                        this,
-                                                                        recipient, tid);
-            }
-
-          uint16_t currentStartingSeq = it->second.first.GetStartingSequence ();
-          uint16_t currentSeq = SEQNO_SPACE_SIZE;   // invalid value
+      NS_ASSERT (blockAck.GetAckType (index) && tids.size () == 1);
+      tid = *tids.begin ();
+    }
+  if (ExistsAgreementInState (recipient, tid, OriginatorBlockAckAgreement::ESTABLISHED))
+    {
+      AgreementsI it = m_agreements.find (std::make_pair (recipient, tid));
 
-          if (blockAck.IsBasic ())
-            {
-              for (PacketQueueI queueIt = it->second.second.begin (); queueIt != queueEnd; )
-                {
-                  currentSeq = (*queueIt)->GetHeader ().GetSequenceNumber ();
-                  if (blockAck.IsFragmentReceived (currentSeq,
-                                                    (*queueIt)->GetHeader ().GetFragmentNumber ()))
-                    {
-                      nSuccessfulMpdus++;
-                    }
-                  else if (!QosUtilsIsOldPacket (currentStartingSeq, currentSeq))
-                    {
-                      if (!foundFirstLost)
-                        {
-                          foundFirstLost = true;
-                          RemoveOldPackets (recipient, tid, currentSeq);
-                        }
-                      nFailedMpdus++;
-                      InsertInRetryQueue (*queueIt);
-                    }
-                  // in any case, this packet is no longer outstanding
-                  queueIt = it->second.second.erase (queueIt);
-                }
-              // If all frames were acknowledged, move the transmit window past the last one
-              if (!foundFirstLost && currentSeq != SEQNO_SPACE_SIZE)
+      if (it->second.first.m_inactivityEvent.IsRunning ())
+        {
+          /* Upon reception of a BlockAck frame, the inactivity timer at the
+              originator must be reset.
+              For more details see section 11.5.3 in IEEE802.11e standard */
+          it->second.first.m_inactivityEvent.Cancel ();
+          Time timeout = MicroSeconds (1024 * it->second.first.GetTimeout ());
+          it->second.first.m_inactivityEvent = Simulator::Schedule (timeout,
+                                                                    &BlockAckManager::InactivityTimeout,
+                                                                    this,
+                                                                    recipient, tid);
+        }
+
+      NS_ASSERT (blockAck.IsCompressed () || blockAck.IsExtendedCompressed () || blockAck.IsMultiSta ());
+      Time now = Simulator::Now ();
+
+      for (auto queueIt = it->second.second.begin (); queueIt != it->second.second.end (); )
+        {
+          uint16_t currentSeq = (*queueIt)->GetHeader ().GetSequenceNumber ();
+          if (blockAck.IsPacketReceived (currentSeq, index))
+            {
+              it->second.first.NotifyAckedMpdu (*queueIt);
+              nSuccessfulMpdus++;
+              if (!m_txOkCallback.IsNull ())
                 {
-                  RemoveOldPackets (recipient, tid, (currentSeq + 1) % SEQNO_SPACE_SIZE);
+                  m_txOkCallback (*queueIt);
                 }
+              queueIt = HandleInFlightMpdu (queueIt, ACKNOWLEDGED, it, now);
             }
-          else if (blockAck.IsCompressed () || blockAck.IsExtendedCompressed () || blockAck.IsMultiSta ())
+          else
             {
-              for (PacketQueueI queueIt = it->second.second.begin (); queueIt != queueEnd; )
+              nFailedMpdus++;
+              if (!m_txFailedCallback.IsNull ())
                 {
-                  currentSeq = (*queueIt)->GetHeader ().GetSequenceNumber ();
-                  if (blockAck.IsPacketReceived (currentSeq, index))
-                    {
-                      it->second.first.NotifyAckedMpdu (*queueIt);
-                      nSuccessfulMpdus++;
-                      if (!m_txOkCallback.IsNull ())
-                        {
-                          m_txOkCallback (*queueIt);
-                        }
-                    }
-                  else if (!QosUtilsIsOldPacket (currentStartingSeq, currentSeq))
-                    {
-                      nFailedMpdus++;
-                      if (!m_txFailedCallback.IsNull ())
-                        {
-                          m_txFailedCallback (*queueIt);
-                        }
-                      InsertInRetryQueue (*queueIt);
-                    }
-                  // in any case, this packet is no longer outstanding
-                  queueIt = it->second.second.erase (queueIt);
+                  m_txFailedCallback (*queueIt);
                 }
+              queueIt = HandleInFlightMpdu (queueIt, TO_RETRANSMIT, it, now);
             }
-          m_stationManager->ReportAmpduTxStatus (recipient, nSuccessfulMpdus, nFailedMpdus, rxSnr, dataSnr, dataTxVector);
         }
     }
-  else
-    {
-      //NOT SUPPORTED FOR NOW
-      NS_FATAL_ERROR ("Multi-tid block ack is not supported.");
-    }
+  return {nSuccessfulMpdus, nFailedMpdus};
 }
   
 void
@@ -567,36 +555,13 @@
   if (ExistsAgreementInState (recipient, tid, OriginatorBlockAckAgreement::ESTABLISHED))
     {
       AgreementsI it = m_agreements.find (std::make_pair (recipient, tid));
-      for (auto& item : it->second.second)
-        {
-          // Queue previously transmitted packets that do not already exist in the retry queue.
-          InsertInRetryQueue (item);
-        }
+      Time now = Simulator::Now ();
+
       // remove all packets from the queue of outstanding packets (they will be
       // re-inserted if retransmitted)
-      it->second.second.clear ();
-    }
-}
-
-void
-BlockAckManager::DiscardOutstandingMpdus (Mac48Address recipient, uint8_t tid)
-{
-  NS_LOG_FUNCTION (this << recipient << +tid);
-  if (ExistsAgreementInState (recipient, tid, OriginatorBlockAckAgreement::ESTABLISHED))
-    {
-      AgreementsI it = m_agreements.find (std::make_pair (recipient, tid));
-      while (!it->second.second.empty ())
+      for (auto mpduIt = it->second.second.begin (); mpduIt != it->second.second.end (); )
         {
-          Ptr<WifiMacQueueItem> mpdu = it->second.second.front ();
-          if (it->second.first.GetDistance (mpdu->GetHeader ().GetSequenceNumber ()) >= SEQNO_SPACE_HALF_SIZE)
-            {
-              // old packet
-              it->second.second.pop_front ();
-            }
-          else
-            {
-              NotifyDiscardedMpdu (mpdu);
-            }
+          mpduIt = HandleInFlightMpdu (mpduIt, TO_RETRANSMIT, it, now);
         }
     }
 }
@@ -612,6 +577,12 @@
       return;
     }
 
+  if (!mpdu->GetHeader ().IsRetry () && !mpdu->IsInFlight ())
+    {
+      NS_LOG_DEBUG ("This frame has never been transmitted");
+      return;
+    }
+
   Mac48Address recipient = mpdu->GetHeader ().GetAddr1 ();
   uint8_t tid = mpdu->GetHeader ().GetQosTid ();
   if (!ExistsAgreementInState (recipient, tid, OriginatorBlockAckAgreement::ESTABLISHED))
@@ -628,12 +599,28 @@
       return;
     }
 
-  // remove outstanding frames and frames in the retransmit queue with a sequence
-  // number less than or equal to the discarded MPDU
-  RemoveOldPackets (recipient, tid, (mpdu->GetHeader ().GetSequenceNumber () + 1) % SEQNO_SPACE_SIZE);
   // actually advance the transmit window
   it->second.first.NotifyDiscardedMpdu (mpdu);
 
+  // remove old MPDUs from the EDCA queue and from the in flight queue
+  // (including the given MPDU which became old after advancing the transmit window)
+  for (auto mpduIt = it->second.second.begin (); mpduIt != it->second.second.end (); )
+    {
+      if (it->second.first.GetDistance ((*mpduIt)->GetHeader ().GetSequenceNumber ()) >= SEQNO_SPACE_HALF_SIZE)
+        {
+          m_queue->DequeueIfQueued (*mpduIt);
+          if (!m_droppedOldMpduCallback.IsNull ())
+            {
+              m_droppedOldMpduCallback (*mpduIt);
+            }
+          mpduIt = it->second.second.erase (mpduIt);
+        }
+      else
+        {
+          break; // MPDUs are in increasing order of sequence number in the in flight queue
+        }
+    }
+
   // schedule a BlockAckRequest
   NS_LOG_DEBUG ("Schedule a Block Ack Request for agreement (" << recipient << ", " << +tid << ")");
   Ptr<Packet> bar = Create<Packet> ();
@@ -808,11 +795,17 @@
       AgreementsI it = m_agreements.find (std::make_pair (recipient, tid));
       NS_ASSERT (it != m_agreements.end ());
 
-      // A BAR needs to be retransmitted if there is at least a non-expired outstanding MPDU
-      for (auto& mpdu : it->second.second)
+      Time now = Simulator::Now ();
+
+      // A BAR needs to be retransmitted if there is at least a non-expired in flight MPDU
+      for (auto mpduIt = it->second.second.begin (); mpduIt != it->second.second.end (); )
         {
-          if (mpdu->GetTimeStamp () + m_queue->GetMaxDelay () > Simulator::Now ())
+          // remove MPDU if old or with expired lifetime
+          mpduIt = HandleInFlightMpdu (mpduIt, STAY_INFLIGHT, it, now);
+
+          if (mpduIt != it->second.second.begin ())
             {
+              // the MPDU has not been removed
               return true;
             }
         }
@@ -824,80 +817,6 @@
 }
 
 void
-BlockAckManager::RemoveFromRetryQueue (Mac48Address address, uint8_t tid, uint16_t seq)
-{
-  RemoveFromRetryQueue (address, tid, seq, seq);
-}
-
-void
-BlockAckManager::RemoveFromRetryQueue (Mac48Address address, uint8_t tid, uint16_t startSeq, uint16_t endSeq)
-{
-  NS_LOG_FUNCTION (this << address << +tid << startSeq << endSeq);
-
-  AgreementsI agreementIt = m_agreements.find (std::make_pair (address, tid));
-  NS_ASSERT (agreementIt != m_agreements.end ());
-
-  /* remove retry packet iterators if they are present in retry queue */
-  WifiMacQueue::ConstIterator it = m_retryPackets->PeekByTidAndAddress (tid, address);
-
-  while (it != m_retryPackets->end ())
-    {
-      uint16_t itSeq = (*it)->GetHeader ().GetSequenceNumber ();
-
-      if (agreementIt->second.first.GetDistance (itSeq) >= agreementIt->second.first.GetDistance (startSeq)
-          && agreementIt->second.first.GetDistance (itSeq) <= agreementIt->second.first.GetDistance (endSeq))
-        {
-          NS_LOG_DEBUG ("Removing frame with seqnum = " << itSeq);
-          it = m_retryPackets->Remove (it);
-          it = m_retryPackets->PeekByTidAndAddress (tid, address, it);
-        }
-      else
-        {
-          it = m_retryPackets->PeekByTidAndAddress (tid, address, ++it);
-        }
-    }
-}
-
-void
-BlockAckManager::RemoveOldPackets (Mac48Address recipient, uint8_t tid, uint16_t startingSeq)
-{
-  NS_LOG_FUNCTION (this << recipient << +tid << startingSeq);
-
-  AgreementsI agreementIt = m_agreements.find (std::make_pair (recipient, tid));
-  NS_ASSERT (agreementIt != m_agreements.end ());
-  uint16_t currStartingSeq = agreementIt->second.first.GetStartingSequence ();
-
-  NS_ABORT_MSG_IF (agreementIt->second.first.GetDistance (startingSeq) >= SEQNO_SPACE_HALF_SIZE,
-                   "The new starting sequence number is an old sequence number");
-
-  if (startingSeq == currStartingSeq)
-    {
-      return;
-    }
-
-  // remove packets that will become old from the retransmission queue
-  uint16_t lastRemovedSeq = (startingSeq - 1 + SEQNO_SPACE_SIZE) % SEQNO_SPACE_SIZE;
-  RemoveFromRetryQueue (recipient, tid, currStartingSeq, lastRemovedSeq);
-
-  // remove packets that will become old from the queue of outstanding packets
-  PacketQueueI it = agreementIt->second.second.begin ();
-  while (it != agreementIt->second.second.end ())
-    {
-      uint16_t itSeq = (*it)->GetHeader ().GetSequenceNumber ();
-
-      if (agreementIt->second.first.GetDistance (itSeq) <= agreementIt->second.first.GetDistance (lastRemovedSeq))
-        {
-          NS_LOG_DEBUG ("Removing frame with seqnum = " << itSeq);
-          it = agreementIt->second.second.erase (it);
-        }
-      else
-        {
-          it++;
-        }
-    }
-}
-
-void
 BlockAckManager::SetBlockAckInactivityCallback (Callback<void, Mac48Address, uint8_t, bool> callback)
 {
   NS_LOG_FUNCTION (this << &callback);
@@ -931,47 +850,9 @@
 }
 
 void
-BlockAckManager::InsertInRetryQueue (Ptr<WifiMacQueueItem> mpdu)
+BlockAckManager::SetDroppedOldMpduCallback (DroppedOldMpdu callback)
 {
-  NS_LOG_INFO ("Adding to retry queue " << *mpdu);
-  NS_ASSERT (mpdu->GetHeader ().IsQosData ());
-
-  uint8_t tid = mpdu->GetHeader ().GetQosTid ();
-  Mac48Address recipient = mpdu->GetHeader ().GetAddr1 ();
-
-  AgreementsI agreementIt = m_agreements.find (std::make_pair (recipient, tid));
-  NS_ASSERT (agreementIt != m_agreements.end ());
-
-  uint16_t mpduDist = agreementIt->second.first.GetDistance (mpdu->GetHeader ().GetSequenceNumber ());
-
-  if (mpduDist >= SEQNO_SPACE_HALF_SIZE)
-    {
-      NS_LOG_DEBUG ("Got an old packet. Do nothing");
-      return;
-    }
-
-  WifiMacQueue::ConstIterator it = m_retryPackets->PeekByTidAndAddress (tid, recipient);
-
-  while (it != m_retryPackets->end ())
-    {
-      if (mpdu->GetHeader ().GetSequenceControl () == (*it)->GetHeader ().GetSequenceControl ())
-        {
-          NS_LOG_DEBUG ("Packet already in the retransmit queue");
-          return;
-        }
-
-      uint16_t dist = agreementIt->second.first.GetDistance ((*it)->GetHeader ().GetSequenceNumber ());
-
-      if (mpduDist < dist ||
-          (mpduDist == dist && mpdu->GetHeader ().GetFragmentNumber () < (*it)->GetHeader ().GetFragmentNumber ()))
-        {
-          break;
-        }
-
-      it = m_retryPackets->PeekByTidAndAddress (tid, recipient, ++it);
-    }
-  mpdu->GetHeader ().SetRetry ();
-  m_retryPackets->Insert (it, mpdu);
+  m_droppedOldMpduCallback = callback;
 }
 
 uint16_t
